### Method

# EDataBook BookSqlite add_contacts

since: 3.12

#### Declaration [src]

    gboolean
    e_book_sqlite_add_contacts (
      EBookSqlite* ebsql,
      GSList* contacts,
      GSList* extra,
      gboolean replace,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Adds or replaces contacts in `ebsql`. If `replace_existing` is specified then existing contacts with the same UID will be replaced, otherwise adding an existing contact will return an error.

If `extra` is specified, it must have an equal length as the `contacts` list. Each element from the `extra` list will be stored in association with it’s corresponding contact in the `contacts` list.

Available since: 3.12

#### Parameters

`contacts`

  Type: A list of `EContact*`

  A list of contacts to add to `ebsql`.

  The data is owned by the caller of the method.

`extra`

  Type: A list of `utf8`

  A list of extra data to store in association with this contact.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  Each element is a NUL terminated UTF-8 string.

`replace`

  Type: `gboolean`

  Whether this contact should replace another contact with the same UID.

`cancellable`

  Type: `GCancellable`

  A `GCancellable`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` on success, otherwise `FALSE` is returned and `error` is set appropriately.